from vcCommand import *

app = getApplication()
teach = getApplication().TeachContext

def OnStart():
  routine = teach.ActiveScope
  
  processStatement = routine.addStatement(VC_STATEMENT_PROCESS, teach.ActiveStatementIndex + 1, "rDetach")
  processStatement.Name = "Detach"+str(teach.ActiveStatementIndex+1)
  
  name = processStatement.getProperty('Name')
  base = processStatement.getProperty('Base')
  tool = processStatement.getProperty('Tool')
  
  processStatement.createProperty(VC_VECTOR, 'ChildVector')
  processStatement.createProperty(VC_STRING, 'ChildName')
  processStatement.createProperty(VC_BUTTON, 'SetChildVector')    
  
  robot = teach.ActiveRobot 
  detachStatementScriptName = 'StatementScript_' + processStatement.Name
  detachStatementScript = robot.findBehaviour(detachStatementScriptName)
  if not detachStatementScript:
    detachStatementScript = robot.createBehaviour(VC_PYTHONPROCESSHANDLER, detachStatementScriptName)
  detachStatementScript.Script = '''
from vcPythonProcessHandler import *
import vcVector

sim = getSimulation()
world_container = sim.World.getBehavioursByType(VC_CONTAINER)[0]
app = getApplication()
snap = app.findCommand('interactiveSnap') 

def ChildPicked(arg):
  global childVector, childName
  target = snap.TargetNode.Component  
  childVector.Value = target.WorldPositionMatrix.P
  childName.Value = target.Name
  
def OnPickComponent(arg):
  snap.clear()   
  if 'Child' in arg.Name:
    snap.OnTargetSet = ChildPicked   
  snap.execute()

def hideOthers(statement):
  name = statement.getProperty('Name')
  name.IsVisible = False
  base = statement.getProperty('Base')
  base.IsVisible = False
  tool = statement.getProperty('Tool')
  tool.IsVisible = False

def setEvents(statement):
  global childVector, childName
  
  childVector = statement.getProperty('ChildVector')
  childName = statement.getProperty('ChildName')
  
  global setChildVector 
  setChildVector = statement.getProperty('SetChildVector')
  if setChildVector:
    if not setChildVector.OnChanged:
      setChildVector.OnChanged = OnPickComponent 

def OnStatementAdd(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)

def OnStatementModified(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
def OnStatementExecute(executor, statement):  
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
  child = None

  if childName.Value != None:
    child = app.findComponent(childName.Value)
    world_container.grab(child)
    



'''
  processStatement.Process = detachStatementScript
  app.SelectionManager.setSelection(processStatement)

